﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Rscja.Deviceapi;
using System.Security.Policy;

namespace xm_Fingerpint
{
	[Activity (Label = "xm_Fingerpint", MainLauncher = true)]
	public class MainActivity : TabActivity
	{

		static Fingerprint fp;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);

			// Get our button from the layout resource,
			// and attach an event to it

			fp = Fingerprint.Instance;

			InitView ();
		}
		void InitView()
		{

			CreateTab(typeof(get), GetString (Resource.String.get), GetString (Resource.String.get), Resource.Drawable.Icon);
			CreateTab(typeof(set), GetString (Resource.String.set), GetString (Resource.String.set), Resource.Drawable.Icon);
			CreateTab(typeof(data), GetString (Resource.String.data), GetString (Resource.String.data), Resource.Drawable.Icon);
			//CreateTab(typeof(Desfire), "Desfire", "Desfire", Resource.Drawable.Icon);
			CreateTab(typeof(setsys), GetString (Resource.String.setsys),GetString (Resource.String.setsys), Resource.Drawable.Icon);

		}

		/// <summary>
		/// Creates the tab.
		/// </summary>
		/// <param name="activityType">类名</param>
		/// <param name="tag">Tag.</param>
		/// <param name="label">Label.</param>
		/// <param name="drawableId">Drawable identifier.</param>
		private void CreateTab(Type activityType, string tag, string label, int drawableId )
		{
			var intent = new Intent(this, activityType);
			intent.AddFlags(ActivityFlags.NewTask);

			var spec = TabHost.NewTabSpec(tag);
			var drawableIcon = Resources.GetDrawable(drawableId);
			spec.SetIndicator(label, drawableIcon);
			spec.SetContent(intent);

			TabHost.AddTab(spec);
		}

		protected override void OnResume()
		{
			base.OnResume ();
			new initfp (this).Execute ();
		}
		protected override void OnPause()
		{
			base.OnPause ();
			if (fp != null)
			{
				fp.Free();
			}
		}
		protected override void OnStop()
		{
			base.OnStop ();

		}


		public override bool OnKeyDown(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{
				//Scan ();
				return true;
			}
			return base.OnKeyDown (code,e);
		}
		public override bool OnKeyUp(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{

				return true;
			}
			return base.OnKeyUp (code,e);
		}


		public class initfp:AsyncTask{

			MainActivity mContext;
			ProgressDialog pro;
			public initfp(MainActivity m)
			{
				mContext=m;
			}

			protected override void OnPreExecute()
			{
				pro = new ProgressDialog (mContext);
				pro.SetProgressStyle (ProgressDialogStyle.Spinner);
				pro.SetMessage ("Fingerprint Init...");
				pro.Show ();

			}
			#region implemented abstract members of AsyncTask

			protected override Java.Lang.Object DoInBackground (params Java.Lang.Object[] @params)
			{
				if (fp.Init()) 
				{//throw new NotImplementedException ();
					//mContext.StartScanThread ();
					PubClass.fp = fp;
					return "OK";
				}
				return "";
			}

			#endregion
			protected override void  OnPostExecute(Java.Lang.Object obj)
			{
				if (obj.ToString() != "OK") {
					Toast.MakeText (mContext,"init failuer",ToastLength.Short).Show();
				}
				else
					Toast.MakeText (mContext,"init OK",ToastLength.Short).Show();
				pro.Cancel ();
			}

		}

	}
}


